### Run an injection
If you want to work directly with your MVA outputs you should "re-inject" them into your Ntuples.
The idea of this process is that the MVA outputs are added as additional branches to the Ntuples. During this process a copy of the Ntuples is produced, including the newly added branches.

To inject NN predictions back into Ntuples you can do:
```sh
python3 python/mva-trainer -i <input_path> -o <output_path> -c <config_path> --processes <n_processes> --filter <filter_string>
```
Hereby `<input_path>` describes the path to input Ntuples. The `<output_path>` argument describes the path to an output directory in which the injected Ntuples will be stored. The directory and the sub-directory structure will automatically be created for you. The config file is **again** passed via the `<config_path>` argument.
You can pass multiple config files simultaneously inject multiple neural networks into Ntuples using the `--additionalconfigs` argument.
Using the *processes* argument you can specify a number of independent processes that are run simultaneously. Each process will inject the prediction into one root file and start a new process upon termination. Using the `filter` argument you can restrict your injection using a string as a wildcard.
Keep in mind that this can be very memory-consuming because the entire root-file is loaded. Restrict this to a lower number (e.g. 2-4) in case you have memory limitations.
